/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

(function($) {

    $(document).ready(function() {

        $('.qftabs').each(function() {
            qfadmin.activateTabs(this);
        });

        if ($('input[name="qffield[p][modal]"]').length) {
            qfadmin.activateProject();
        }

        $('input[name="cid[]"]').change(function() {
            qfadmin.toolbartoggle();
        });
        qfadmin.toolbartoggle();

        $('a.js_sort_dir').click(function() {
            qfadmin.filterdir(this);
        });

        $('.js_sort_list').change(function() {
            qfadmin.filterlist(this);
        });

        if ($('select[name="qffield[addfiles]"').length) {
            qfadmin.disfiles();
        }

        // $('#adminmenuwrap li a').each(function () {
		// 	if (this.href.indexOf('qf3-forms') != -1) $(this).remove();
		// });

        qfadmin.filled();


        // joomla 4 menu
        $('#sidebarmenu .item-level-3 a').each(function() {
            if (this.href.indexOf('com_qf3') + 1) {
                $(this).addClass('qfmenuitem');

                if (this.href.indexOf('projects') + 1) {
                    $(this).addClass('qfprojects');
                }
                else if (this.href.indexOf('historys') + 1) {
                    $(this).addClass('qfhistorys');
                }
                else if (this.href.indexOf('settings') + 1) {
                    $(this).addClass('qfsettings');
                }
                else if (this.href.indexOf('shop') + 1) {
                    $(this).addClass('qfshop');
                }
                else if (this.href.indexOf('attachment') + 1) {
                    $(this).addClass('qfattachment');
                }
            }
        });

    });


    return qfadmin = {
        filled: function() {
            let els = $('.qf3_filter input').add('.qf3_filter select');
            let fill = function() {
                els.each(function(){
                    if($(this).val()) $(this).addClass('filled');
                    else $(this).removeClass('filled');
                });
            }
            els.on('change', function(){
                fill();
            });
            fill();
        },

        toolbartoggle: function() {
            var btns = $('.activate, .deactivate, .delete', $('.qf3_toolbar'));
            $('input[name="cid[]"]:checked').length ? btns.removeClass('qfdisabled') : btns.addClass('qfdisabled');
        },

        filterdir: function(el) {
            var col = $(el).data('order').split('.');
            var form = document.forms.qfadminform;
            $('<input type="hidden" name="task" value="'+col[0] + '.filterdir">').appendTo(form);
            $('<input type="hidden" name="col" value="'+col[1]+'">').appendTo(form);
            form.submit();
        },

        filtersearch: function() {
            var col = $('input.search').data('order').split('.');
            var form = document.forms.qfadminform;
            $('<input type="hidden" name="task" value="'+col[0] + '.filterlist">').appendTo(form);
            $('<input type="hidden" name="col" value="'+col[1]+'">').appendTo(form);
            $('<input type="hidden" name="v" value="">').appendTo(form).val($('input.search').val());
            form.submit();
        },

        filterlist: function(el) {
            var col = $(el).data('order').split('.');
            var val = $(el).val();
            var form = document.forms.qfadminform;
            $('<input type="hidden" name="task" value="'+col[0] + '.filterlist">').appendTo(form);
            $('<input type="hidden" name="col" value="'+col[1]+'">').appendTo(form);
            $('<input type="hidden" name="v" value="'+val+'">').appendTo(form);
            form.submit();
        },

        qflistedit: function(task) {
            var form = document.forms.qfadminform;
            $('<input type="hidden" name="task" value="'+task+'">').appendTo(form);
            if (task.split('.')[1] == 'close') form.submit();
            else $('<input type="submit">').appendTo(form).click();
        },

        help: function(task) {
            $.ajax({
                url: "index.php?option=com_qf3&task="+task,
                success: function(msg) {
                    $('.helpbox').remove();
                    $('<div class="helpbox"><div class="qfmessboxclose" onclick="this.parentNode.parentNode.removeChild(this.parentNode)">✕</div>'+msg+'</div>').insertBefore(document.forms.qfadminform);
                }
            });
        },

        activateTabs: function(e) {
            var items = $(e).children('.qftabsitem');

            items.each(function(i) {
                $(this).hide(0);
            });
            items[0].style.display = 'block';

            var labels = $('.qftabsitemlabel', $(e).children('.qftabslabelsbox'));
            labels.on('click', function() {
                labels.removeClass('qftabactiv');
                $(this).addClass('qftabactiv');
                items.css('display', 'none');
                for (var i = 0; i < labels.length; i++) {
                    if (labels[i] == this) items[i].style.display = 'block';
                }
            });

            var radioyesno = function() {
                $('.radioyesno').each(function() {
                    if (this.checked) $(this).parent().addClass('checked');
                    else $(this).parent().removeClass('checked');
                });
            }
            radioyesno();

            $('.radioyesno').change(function() {
                radioyesno();
            });
        },

        activateProject: function() {
            var modallink = function() {
                var box = $('input[name="qffield[p][modallink]"]').closest('.qffield');
                if ($('input[name="qffield[p][modal]"]:checked').val() == 1) {
                    box.show(200);
                } else {
                    box.hide(200);
                }
            }
            modallink();
            $('input[name="qffield[p][modal]"]').change(function() {
                modallink();
            });


            var csschoose = function() {
                var n = $('input[name="qffield[csschoose]"]:checked').val();
                var box1 = $('.box_cssform');
                var box2 = $('.box_createcssfile');
                var box3 = $('.box_copycssfile');
                if (n == 'y') {
                    box1.show(200);
                    box2.hide(200);
                    box3.hide(200);
                } else {
                    box1.hide(200);
                    box2.show(200);
                    box3.show(200);
                }
            }
            csschoose();

            $('input[name="qffield[csschoose]"]').change(function() {
                csschoose();
            });


            var calculatordesk = function() {
                $('.cdesk').hide(100);
                var n = $('input[name="qffield[p][calculatortype]"]:checked').val();
                $('.cdesk_' + n).show(100);

                var box = $('.box_calcformula');
                if (n != '0' && n != 'default') {
                    box.show(100);
                } else {
                    box.hide(100);
                }
            }
            calculatordesk();

            $('input[name="qffield[p][calculatortype]"]').change(function() {
                calculatordesk();
            });
        },

        checkAll: function(checkbox, stub) {
            if (!checkbox.form) {
                return false;
            }

            var currentStab = stub || 'cb';
            var elements = [].slice.call(checkbox.form.elements);
            elements.forEach(function(element) {
                if (element.type === checkbox.type && element.name === 'cid[]') {
                    element.checked = checkbox.checked;
                }
            });

            return true;
        },

        disfiles: function() {
            var sel = $('select[name="qffield[addfiles]"]');
            var func = function() {
                var fld2 = $('input[name="qffield[reqfiles]"]').closest('.qffield');
                var fld3 = $('input[name="qffield[accept]"]').closest('.qffield');
                var fld4 = $('input[name="qffield[whitelist]"]').closest('.qffield');
                fld2.add(fld3).add(fld4).hide();
                if (1 * sel.val()) {
                    fld2.add(fld3).show();
                    if (1 * $('input[name="qffield[accept]"]:checked').val()) {
                        fld4.show();
                    }
                }
            }
            sel.add($('input[name="qffield[accept]"]')).on('change', function() {
                func();
            })
            func();
        },


    }
})(jQuery);
