<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace QuickForm;

\defined('QF3_VERSION') or die;

class formsModel extends baseModel
{
    public $itemscount;
    public $projectid;
    public $total;

    public function __construct()
    {
        $this->projectid = (int) $this->get('projectid', $_REQUEST);
        $this->closelink = 'projects&task=forms&projectid=' . $this->projectid;
    }

    public function getItems()
    {
        $db = \JFactory::getDbo();

        $ses = qf_session::get('quickform');
        $filterdir = $this->get('filterdir', $ses, []);

        $order = $this->get('order', $filterdir, 'id');
        if (! in_array($order, array('def', 'title'))) {
            $order = 'id';
        }

        $dir = $this->get('dir', $filterdir) == 'asc' ? 'asc' : 'desc';
        $limit = 12;

        if (! $filterdir) {
            $_SESSION['quickform']['filterdir'] = array('order'=>$order, 'dir'=>$dir);
        }

        $filterlist = $this->get('filterlist', $ses, []);
        $where = array();

        foreach ($filterlist as $k=>$v) {
            if ($v && $k == 'forms.search') {
                $v = '\'%'.addslashes(addcslashes(htmlspecialchars_decode(trim($v), ENT_QUOTES), '_%\\' )).'%\'';
                $where[] = '(title LIKE ' . $v . ' OR fields LIKE ' . $v . ')';
            } elseif ($v && $k == 'forms.limit') {
                $limit = (int) $v;
            }
        }

        $active = isset($_GET['start']) ? (int) $_GET['start'] : 1;
        $start = ($active-1)*$limit;

        if ($this->projectid) {
            $where[] = 'projectid='. (int) $this->projectid;
        }

        if ($where) {
            $where = ' WHERE ' . implode(' AND ', $where);
        } else {
            $where = '';
        }

        $db->setQuery( 'SELECT * FROM #__qf3_forms' .$where. ' ORDER BY ' .$order. ' ' .$dir. ' LIMIT ' .$start. ',' .$limit );
        $data = $db->loadObjectList();

        $db->setQuery( 'SELECT COUNT(*) FROM #__qf3_forms' .$where );
        $this->itemscount = $db->loadResult();

        $db->setQuery( 'SELECT COUNT(*) FROM #__qf3_forms WHERE projectid='. (int) $this->projectid);
        $this->total = $db->loadResult();

        return $data;
    }

    public function getProjectTitle()
    {
        $db = \JFactory::getDbo();

        $db->setQuery( 'SELECT title FROM #__qf3_projects WHERE id = '.(int) $this->projectid );
        return $db->loadResult();
    }


    public function changeDef()
    {
        $db = \JFactory::getDbo();

        $id = (int) $this->get('id', $_GET);
        if ($id) {
            $db->setQuery( 'SELECT projectid FROM #__qf3_forms WHERE id = '.$id );
            $projectid = $db->loadResult();

            $db->setQuery(
                'UPDATE #__qf3_forms SET def = 1 - def WHERE (def = 1 AND projectid = '.(int) $projectid.') OR id = '.$id
            );
            $db->execute();

            return $projectid;
        }
    }
}
