<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace QuickForm;

\defined('QF3_VERSION') or die;

class historysModel extends baseModel
{
    public $itemscount;

    public function __construct()
    {
        $this->closelink = 'historys';
    }

    public function getItems()
    {
        $db = \JFactory::getDbo();

        $ses = qf_session::get('quickform');
        $filterdir = $this->get('filterdir', $ses, []);

        $order = $this->get('order', $filterdir, 'id');
        if(! in_array($order, array('st_status', 'st_title', 'st_date', 'st_ip', 'st_user'))) {
            $order = 'id';
        }
        $dir = $this->get('dir', $filterdir) == 'asc' ? 'asc' : 'desc';


        $limit = 12;

        if (! $filterdir) {
            $_SESSION['quickform']['filterdir'] = array('order'=>$order, 'dir'=>$dir);
        }

        $filterlist = $this->get('filterlist', $ses, []);
        $where = array();

        foreach($filterlist as $k=>$v) {
            if(($v !== '') && $k == 'historys.st_status') $where[] = 'st_status='. (int) $v;
            elseif($v && $k == 'historys.search') {
                $v = '\'%'.addslashes(addcslashes(htmlspecialchars_decode(trim($v), ENT_QUOTES), '_%\\' )).'%\'';
                $where[] = '(st_title LIKE ' . $v . ' OR st_desk LIKE ' . $v . ' OR st_form LIKE ' . $v . ')';
            }
            elseif($v && $k == 'historys.limit') $limit = (int) $v;
        }

        $active = (int) $this->get('start', $_GET, 1);
        $start = ($active-1)*$limit;

        if($where) {
            $where = ' WHERE ' . implode(' AND ', $where);
        }
        else $where = '';
        // print_r('SELECT * FROM #__qf3_ps' .$where. ' ORDER BY ' .$order. ' ' .$dir. ' LIMIT ' .$start. ',' .$limit);die;

        $db->setQuery( 'SELECT * FROM #__qf3_ps' .$where. ' ORDER BY ' .$order. ' ' .$dir. ' LIMIT ' .$start. ',' .$limit );
        $data = $db->loadObjectList();

        $db->setQuery( 'SELECT COUNT(*) FROM #__qf3_ps' .$where );
        $this->itemscount = $db->loadResult();

        return $data;
    }

    public function delete($page)
    {
        parent::delete('ps');
    }

    public function statusfields()
    {
        return array(''=>'QF_NOT_SELECTED', 0=>'QF_NEW', 1=>'QF_UNDERWAY', 2=>'QF_ACHIEVED');
    }


}
