<?php
/**
* @Copyright ((c) plasma-web.ru
        * @license    GPLv2 or later
        */

namespace QuickForm;

\defined('QF3_VERSION') or die;

class projectsModel extends baseModel
{
    public $itemscount;

    public function __construct()
    {
        $this->closelink = 'projects';
    }

    public function getItems()
    {
        $db = \JFactory::getDbo();

        $ses = qf_session::get('quickform');
        $filterdir = $this->get('filterdir', $ses, []);

        $order = $this->get('order', $filterdir, 'id');
        if(! in_array($order, array('published', 'title', 'hits', 'access', 'language'))) {
            $order = 'id';
        }
        $dir = $this->get('dir', $filterdir) == 'asc' ? 'asc' : 'desc';

        $limit = 12;

        if (! $filterdir) {
            $_SESSION['quickform']['filterdir'] = array('order'=>$order, 'dir'=>$dir);
        }

        $filterlist = $this->get('filterlist', $ses, []);
        $where = array();

        foreach($filterlist as $k=>$v) {
            if(($v !== '') && $k == 'projects.published') $where[] = 'published='. (int) $v;
            elseif($v && $k == 'projects.language') $where[] = 'language="'. addslashes( $v ) . '"';
            elseif($v && $k == 'projects.access') $where[] = 'access="'. addslashes( $v ) . '"';
            elseif($v && $k == 'projects.search') {
                $v = '\'%'.addslashes(addcslashes(htmlspecialchars_decode(trim($v), ENT_QUOTES), '_%\\' )).'%\'';
                $where[] = '(title LIKE ' . $v . ' OR params LIKE ' . $v . ')';
            }
            elseif($v && $k == 'projects.limit') $limit = (int) $v;
        }

        $active = (int) $this->get('start', $_GET, 1);
        $start = ($active-1)*$limit;

        if($where) {
            $where = ' WHERE ' . implode(' AND ', $where);
        }
        else $where = '';

        $db->setQuery( 'SELECT * FROM #__qf3_projects' .$where. ' ORDER BY ' .$order. ' ' .$dir. ' LIMIT ' .$start. ',' .$limit );
        $data = $db->loadObjectList();

        $db->setQuery( 'SELECT COUNT(*) FROM #__qf3_projects' .$where );
        $this->itemscount = $db->loadResult();

        return $data;
    }

    public function delete($page)
    {
        $db = \JFactory::getDbo();
        $new_id = $this->checkcid();

        if($new_id) {
            $db->setQuery( 'DELETE FROM #__qf3_forms WHERE projectid IN ('.implode(',', $new_id).')' );
            $db->execute();
            $res1 = $db->getAffectedRows();
            $db->setQuery( 'DELETE FROM #__qf3_projects WHERE id IN ('.implode(',', $new_id).')' );
            $db->execute();
            $res2 = $db->getAffectedRows();

            if($res1 === false || !$res2) $this->errors[] = 'QF_ERR_DATABASE';
            else $this->messages[] = $res1.' '.'QF_N_GROUPS_DELETED'.'; '.$res2.' '.'QF_N_PROJECTS_DELETED';

        }
    }

}
