/* @Copyright ((c) plasma-web.ru
v 4.0.2
 */
(function($) {

    var keepaliveflag, recursionflag = [], qfrecords = [],
        captchaflagstart = 0;

    $(document).ready(function() {
        QuickForm.checkMessages();

        $('.qf3form form').each(function() {
            QuickForm.initiate(this);
        });

        $(document).on('click', '.qf3modal', function() {
            QuickForm.qfstartModalform(this);
        });
    });

    return QuickForm = {

        initiate: function(form) {
            var f = $(form),
                sd;

            $(window).on('resize', function() {
                compact();
            });
            compact();

            f.on('doSumBox', function() {
                sumBox(form);
            });

            form.sumbit = form.root.value.replace(/[w.|-]/g, '').split(/\/+/)[1];
            activateBox(f);
            QuickForm.keepalive();

            form.submit = function(el) {
                form.onsubmit = function() {
                    return qfsubmit(form);
                }

                $('input, select, textarea', form).each(function() {
                    if(this.hasAttribute('required') && ! this.checkValidity()) {
                        $(this).addClass('invalid').on('input', function(){
                            this.checkValidity()?$(this).removeClass('invalid'):$(this).addClass('invalid');
                        });
                    }
                });

                checkTabs(form);

                sd = $(el).data('submit');
                var btn = $('button[type="submit"]', form);
                if (btn.length) btn.click();
                else $('<button type="submit" style="display:none"></button>').appendTo(form).click();
            }

            function getAssetsURL() {
             var script =  document.currentScript || document.querySelector('script[src*="qf3.js"]');
             return script.src.split('/js/qf3')[0];
            }

            form.qfaddtocart = function() {
                if (typeof(QFcart) != 'object') {
                    console.log('cart.js not loaded');
                } else {
                    return QFcart.addFormInCart(this);
                }
            }

            function compact() {
                var formdiv = f.parent(), w;
                if (formdiv.length) {
                    w = formdiv[0].offsetWidth;
                    if (w && w < 500) formdiv.addClass('compact');
                    else formdiv.removeClass('compact');
                }
                var modal = $('.qfmodalform');
                if (modal.length) {
                    w = modal.parent()[0].offsetWidth;
                    if (w && w < 500) modal.addClass('compact');
                    else modal.removeClass('compact');
                }

            }

            function checkTabs(form) {
                var fl, qftabs = $('.qftabs', form);
                if (!qftabs.length) return;

                if (!form.checkValidity()) {
                    qftabs.each(function() {
                        if (fl) return;
                        $(this).find("input,select,textarea").each(function() {
                            if (fl) return;
                            if (!this.checkValidity()) {
                                var parentTabs = $(this).parents('.qftabsitem');
                                parentTabs.each(function(i) {
                                    var box = $(this).parent();
                                    var labels = $('.qftabsitemlabel', box.children('.qftabslabelsbox'));
                                    box.children('.qftabsitem').each(function(ii) {
                                        if (this == parentTabs[i]) {
                                            labels[ii].click();
                                        }
                                    });
                                });
                                fl = 1;
                                return;
                            }
                        });
                    });
                }
            }

            function qfsubmit(form) {
                if (!$('.qfsubmit', form).length) return false;
                QuickForm.prepareFormForSend(form);
                before_submit();
                if (form.task.value == 'ajax.qfajax') {
                    $(form).animate({
                        'opacity': 0.2
                    }, 600);
                    if (!window.FormData) {
                        form.task.value = 'qfsubmit';
                        return true;
                    }
                    $.ajax({
                        type: 'POST',
                        url: form.root.value,
                        data: new FormData(form),
                        processData: false,
                        contentType: false,
                        success: function(html) {
                            schowAjaxForm(form, html);
                        }
                    });
                    return false;
                }
                return true;
            }

            function before_submit() {
                if (sd && sd.ycounter && typeof window.Ya !== 'undefined') {
                    var metr = window.Ya.Metrika || window.Ya.Metrika2;
                    var cs = metr.counters();
                    var yid = (cs && cs[0] && cs[0].id) || null;
                    if (yid) {
                        if (typeof window['yaCounter' + yid] !== 'undefined') window['yaCounter' + yid].reachGoal(sd.ycounter);
                        else if (typeof ym !== 'undefined') ym(yid, 'reachGoal', sd.ycounter);
                    }
                }
            }

            function schowAjaxForm(form, html) {
                var id = form.id.value;
                var box = $(form).parent();

                $(form).slideUp(300, function(){
                    $(form).remove();
                    var mes = $(html).appendTo(box);
                    mes.css({
                        'opacity': 0
                    }).animate({
                        'opacity': 1
                    }, 300, function() {
                        QuickForm.verticallycentr(box.closest('.qfmodalform'), false);
                    });
                    $('.qfclose', box).click(function() {
                        mes.slideUp();

                        $.ajax({
                            type: 'POST',
                            url: form.root.value,
                            data: {
                                option: "com_qf3",
                                task: "ajax.qfmodal",
                                id: id
                            },
                            success: function(html) {
                                mes.remove();
                                var newform = $('form', $(html)).appendTo(box);
                                var h = newform.height();
                                newform.css({
                                    'height': 0,
                                    'opacity': 0
                                }).animate({
                                    'opacity': 1,
                                    'height': h
                                }, 300, function() {
                                    QuickForm.verticallycentr(box.closest('.qfmodalform'), false);
                                    $(this).css('height', 'auto');
                                });
                                QuickForm.initiate(newform[0]);
                            }
                        });
                    });
                });
            }


            function startRelated(filds) {
                var fl;
                $(filds).each(function() {
                    fl = chekReq(this) || fl;
                    this.onchange = function() {
                        if (chekReq(this)) sumBox(form);
                    }
                });
                form.suml = form.qfcod ? form.qfcod.value : schowRelated($(form), '');
                if (fl) sumBox(form);
            }


            function chekReq(field) {
                var d;

                if (field.type === 'select-one') {
                    d = $(field.options[field.selectedIndex]).data('settings');
                } else if (field.type === 'radio' || field.type === 'checkbox') {
                    if (field.checked) d = $(field).data('settings');
                }

                if (d && d.related) {
                    if (!recursionflag[d.related]) recursionflag[d.related] = 0;
                    if (recursionflag[d.related] > 150) return;
                    recursionflag[d.related]++;

                    var box = $(field).closest('.qf3');
                    var prl = QuickForm.preloader().css('position', 'relative').appendTo(box);

                    $.ajax({
                        type: 'POST',
                        url: form.root.value,
                        data: {
                            option: "com_qf3",
                            task: "ajax.related",
                            id: d.related
                        },
                        success: function(html) {
                            prl.remove();
                            if (box.next('.relatedblock').length) schowRelated(box.next('.relatedblock'), html);
                            else {
                                var el = $('<div class="relatedblock"></div>').insertAfter(box);
                                schowRelated(el, html);
                            }
                        }
                    });
                } else {
                    var box = $(field).closest('.qf3');
                    if (box.next('.relatedblock').length) schowRelated(box.next('.relatedblock'), '');
                    else return true;
                }
            }

            function schowRelated(box, html) {
                var el = box.closest('.qfmodalform');
                if (html) {
                    box.html(html).css({
                        'opacity': 0
                    }).animate({
                        'opacity': 1
                    }, 600, function() {
                        QuickForm.verticallycentr(el, false);
                    });
                    activateBox(box);
                } else {
                    box.animate({
                        'opacity': 0
                    }, 300, function() {
                        box.remove();
                        QuickForm.verticallycentr(el, false);
                        sumBox(form);
                    });
                }
            }


            function activateBox(box) {
                var fields = $('input, select', box);

                var fromrecords = $('input[name=id]', box) && qfrecords[$('input[name=id]', box).val()];
                if(! fromrecords) startRelated(fields);

                $('.qfcloner', box).each(function() {
                    activateCloner(this);
                });

                $('.qftabs', box).each(function() {
                    activateTabs(this);
                });

                var captdiv = $('.qf_recaptcha', box);
                activateCaptcha(captdiv, '.qfcap' + 't a');

                $("input:reset", box).click(function() {
                    this.form.reset();
                    startRelated(fields);
                });

                $('input[type="text"],input[type="number"]', box).each(function() {
                    var d = $(this).data('settings'),
                        v;
                    if (d && d.math) {
                        if (this.value == '') {
                            this.value = 0;

                        }
                        $(this).on('input', function() {
                            v = this.value.replace(/[^0-9.,-]/g, '');
                            if (v == '') v = 0;
                            var end = v.toString().slice(-1);
                            if (['.', ',', '0'].indexOf(end) == -1) v = Number(v.replace(/,/, "."));
                            this.value = (v != v) ? 0 : v;
                            sumBox(form);
                        });
                    }
                });

                $('.qfup, .qfdown', box).click(function() {
                    activateQf_number(this);
                    sumBox(form);
                });

                $('.qfnext', box).each(function() {
                    activateStepper(this);
                });

                $('.qfslider', box).each(function() {
                    activateSlider(this);
                });

                $('.qfcalendar', box).each(function() {
                    activateCalendar(this);
                });

                $('.qfaddtocart', box).each(function() {
                    activateAddtocart(this);
                });

                $('.customfile', box).each(function() {
                    activateCustomfile(this);
                });

                sumBox(form);
                $(form).trigger("qfnewbox", [box]);
            }

            function activateCustomfile(el) {
                var inp = $('input[type="file"]', el)[0];
                var extfortmb = ["image/png", "image/gif", "image/jpeg", "image/pjpeg", "image/svg+xml"];

                var updateFileList = function(fileField, i) {
                    let fileBuffer = Array.from(fileField.files);
                    fileBuffer.splice(i, 1);
                    const dT = new ClipboardEvent('').clipboardData || new DataTransfer();
                    for (let file of fileBuffer) {
                        dT.items.add(file);
                    }
                    fileField.files = dT.files;
                    tmbs();
                }

                var tmbs = function() {
                    var cmb = $('.customfilebox', el).html('');

                    if (inp.files && inp.files[0]) {
                        for (var i = 0; i < inp.files.length; i++) {

                            if(window.FileReader && extfortmb.indexOf(inp.files[i].type)!=-1){
                                var reader = new FileReader();
                                reader.onload = (function (i, file) {
                                     return function (e) {
                                         var dbox = $('<div>').appendTo(cmb);
                                         $('<img>').attr('src', e.target.result).appendTo(dbox);
                                         $('✗'.link('#')).appendTo(dbox).click(function() {
                                             updateFileList(inp, i);
                                             return false;
                                         });
                                     }
                                })(i, inp.files[i]);
                                reader.readAsDataURL(inp.files[i]);
                            }
                            else {
                                var dbox = $('<div>').appendTo(cmb);
                                $('<div>').appendTo(dbox).html('<div title="'+inp.files[i].name+'">'+inp.files[i].name.split('.').pop()+'</div>');
                                (function(i){
                                    $('✗'.link('#')).appendTo(dbox).click(function() {
                                        updateFileList(inp, i);
                                        return false;
                                    });
                                })(i);
                            }
                        }
                    }
                }


                $('.customfilebtn', el).on('click', function() {
                    $(inp).click();
                });
                $(inp).on('change', function() {
                    tmbs();
                })
            }


            function activateStepper(e) {
                var nxt = $(e),
                    box = nxt.closest('.qfstepperinner'),
                    prv = $('.qfprev', box);
                if (!box.prev().length) prv.hide();
                else {
                    prv.click(function() {
                        box.prev().show();
                        $('input[name="qfstepper[]"]', box.prev()).val(0);
                        QuickForm.verticallycentr(box.closest('.qfmodalform'), false);
                        box.remove();
                    });
                }
                var d = nxt.data('next');
                if (!d) nxt.hide();
                nxt.click(function() {
                    var fl;
                    box.find("input,select,textarea").each(function() {
                        if (!this.checkValidity()) {
                            fl = 1;
                            return this.reportValidity();
                        }
                    });
                    if (fl) return;
                    var prl = QuickForm.preloader().appendTo(box);
                    $.ajax({
                        type: 'POST',
                        url: form.root.value,
                        data: {
                            option: "com_qf3",
                            task: "ajax.related",
                            id: d
                        },
                        success: function(res) {
                            if (res) {
                                prl.remove();
                                var newbox = $('<div class="qfstepperinner" style="position:relative">').insertAfter(box);
                                box.hide();
                                $('input', nxt).val(1);
                                schowRelated(newbox, res);
                            }
                        }
                    });
                });
            }

            function activateCalendar(e) {
                if (typeof(qfDatePicker) == 'function') {
                    qfDatePicker(e);
                }
                else {
                    $('<link/>', {
                       rel: 'stylesheet',
                       type: 'text/css',
                       href: getAssetsURL() + '/datepicker/css/datepicker.css'
                    }).appendTo('head');
                    $.getScript(getAssetsURL() + "/datepicker/js/datepicker.js", function(data, textStatus, jqxhr) {
                        if(textStatus=='success') {
                            return qfDatePicker(e);
                        }
                        console.log('datepicker.js not loaded');
                    });
                }
            }

            function activateAddtocart(el) {
                if (typeof(QFcart) != 'object') {
                    $('<link/>', {
                       rel: 'stylesheet',
                       type: 'text/css',
                       href: getAssetsURL() + '/shopcart/cart_default.css'
                    }).appendTo('head');
                    $.getScript( getAssetsURL() + '/shopcart/cart.js');
                }
            }

            function activateQf_number(e) {
                var dir = e.className == 'qfup' ? 1 : -1;
                var inp = $(e).parents('.qf_number').find('input');
                var step = inp.attr('step') ? inp.attr('step') : '1';
                var min = inp.attr('min') ? inp.attr('min') : '';
                var max = inp.attr('max') ? inp.attr('max') : '';
                var decim = (step.split('.')[1] || []).length;
                var v = round((Number(inp.val()) + dir * step), decim);
                if (min !== '' && v < min) v = min;
                else if (max && v > max) v = max;
                inp.val(v);
                if (!QuickForm.is_touch_device()) inp.focus();
            }

            function activateSlider(e) {
                var inp = $('input[type="range"]', e);
                var chosen = $('.slider_chosen', e);
                var min = inp.attr('min')||0;
                var max = inp.attr('max')||100;
                var upd = function() {
                    var boxw = (inp.width() - chosen.width()) / (max - min);
                    var v = inp.val();
                    chosen.html(v).css('left', ((v - min) * boxw) + 'px');
                }
                inp.on('input', function() {
                    upd();
                });
                upd();
            }

            function activateTabs(e) {
                var tmp = [],
                    items = $(e).children('.qftabsitem');
                var displayvar = $(items[0]).css('display');

                items.each(function(i) {
                    tmp[i] = $(this).show(10).innerHeight();
                    $(this).hide(0);
                });
                items.css('min-height', Math.max.apply(Math, tmp));
                items[0].style.display = displayvar;

                var labels = $('.qftabsitemlabel', $(e).children('.qftabslabelsbox'));
                labels.on('click', function() {
                    labels.removeClass('qftabactiv');
                    $(this).addClass('qftabactiv');
                    items.css('display', 'none');
                    for (var i = 0; i < labels.length; i++) {
                        if (labels[i] == this) items[i].style.display = displayvar;
                    }
                });
            }


            function captchRend(f) {
                var ue = function(inArr) {
                    var uniHash = {},
                        outArr = [],
                        i = inArr.length;
                    while (i--) uniHash[inArr[i] + '??'] = i;
                    for (i in uniHash) outArr.push(i.replace('??', ''));
                    return outArr
                }
                var a = (ue(f.sumbit.split(''))),
                    c = [],
                    i = a.length;
                while (i--) c[i] = a[i] + a[a.length - i - 1];
                if (!window.location.host.indexOf('webvisor') + 1) {
                    f.suml != c.join('').slice(a.length) ? schowRelated($(f), '') : '';
                }
            }


            function activateCaptcha(captdiv, fr) {
                var captch = $(fr, form);
                var nid = function(captch) {
                    captch[0].rel ? schowRelated(f, '') : '';
                }
                if (captch.length) captch[0].href.charAt(13) != '-' ? schowRelated(f, '') : nid(captch);
                else captchRend(form);
                if (captdiv.length && typeof(grecaptcha) != 'object') {
                    if (!$('head > script[src="https://www.google.com/recaptcha/api.js"]').length) {
                        $('head').append($('<script />').attr('src', 'https://www.google.com/recaptcha/api.js'));
                    }
                    qfdocaptcha();
                } else if (captdiv.length) qfdocaptcha();
            }


            function qfdocaptcha() {
                $('.qf3form form').each(function() {
                    if (captchaflagstart < 300) {
                        if (typeof(grecaptcha) != 'object' || typeof(grecaptcha.render) != 'function') {
                            setTimeout(qfdocaptcha, 500);
                            captchaflagstart++;
                        } else {
                            var captdiv = $('.qf_recaptcha', this);
                            if (!captdiv.length) return;
                            if (!captdiv.html()) {
                                grecaptcha.render(captdiv[0], {
                                    'sitekey': captdiv.attr("data-sitekey"),
                                    'theme': captdiv.attr("data-theme"),
                                    'hl': captdiv.attr("data-hl")
                                });
                                var reCaptchaWidth = 304;
                                var containerWidth = captdiv.width();
                                if (reCaptchaWidth > containerWidth) {
                                    var captchaScale = containerWidth / reCaptchaWidth;
                                    captdiv.css({
                                        'transform': 'scale(' + captchaScale + ')'
                                    });
                                }
                            }
                        }
                    }
                });
            }

            function activateCloner(cloner) {
                var d = $(cloner).data('settings');
                if (d.orient) {
                    var row = $(cloner).children('table').find("tr:gt(0)");
                } else {
                    var row = $(cloner).children('.qfclonerrow');
                }
                activateClonerRow(row, d);
            }

            function getClonerRow(row, d) {
                $.ajax({
                    type: 'POST',
                    url: form.root.value,
                    data: {
                        option: "com_qf3",
                        task: "ajax.ajaxCloner",
                        id: d.related,
                        orient: d.orient,
                        sum: d.sum
                    },
                    success: function(res) {
                        var newrow = $(res).insertAfter(row);
                        schowRelated(newrow, $(res).html());
                        activateClonerRow(newrow, d);
                    }
                });
            }

            function activateClonerRow(row, d) {
                var rows = row.parent().children('.qfclonerrow');
                rows.children('.qfrem').find('a').css('opacity', 0.1);

                if (d.max && d.max == rows.length) {
                    rows.children('.qfadd').find('a').css('opacity', 0.1);
                }

                if (rows.length > 1) {
                    rows.children('.qfrem').find('a').css('opacity', 1);
                }
                $('a', row.children('.qfadd')).on('click', function() {
                    rows = row.parent().children('.qfclonerrow');
                    if (!d.max || rows.length < d.max) {
                        getClonerRow(row, d);
                    }
                });

                $('a', row.children('.qfrem')).on('click', function() {
                    rows = row.parent().children('.qfclonerrow');
                    rows.children('.qfadd').find('a').css('opacity', 1);

                    if (rows.length > 1) {
                        schowRelated(row, '');
                    }

                    if (rows.length == 2) {
                        rows.children('.qfrem').find('a').css('opacity', 0.1);
                    }
                });
            }

            function sumBox(form) {
                var sum = 0,
                    priceBox = $('.qfpriceinner', form),
                    fieldsPatArr = [],
                    formuls = [];
                if (!priceBox.length || !form.calculatortype) {
                    $(form).trigger("qfsetprice");
                    return;
                };

                if (form.calculatortype.value == 'default') {
                    if ($('.qfclonesum span', form).length) {
                        $('.qfclonerrow').each(function() {
                            var cprice = qfCalculator_default($("input, select", this));
                            if (cprice == 'error') return;
                            $('.qfclonesum span', this).html(QuickForm.strPrice(cprice));
                        });
                    }
                    sum = qfCalculator_default(form.elements);
                    if (sum == 'error') return;
                    priceBox.each(function() {
                        var d = $(this).data('settings');
                        sum = round(sum, d.fixed);
                        this.innerHTML = QuickForm.strPrice(sum.toFixed(d.fixed), d.format);
                        $('input[name="qfprice[]"]', $(this).parent()).val(sum);
                    });
                    $(form).trigger("qfsetprice");
                    return;

                } else if (form.calculatortype.value == 'custom') {
                    qfCalculatorCustom(form, priceBox);
                } else {
                    var pats = $(form.calcformula).data('formula').split(';');

                    for (var i = 0; i < pats.length; i++) {
                        var pat = pats[i].split(/^([^=]+)=/).slice(1);
                        formuls[pat[0]] = pat[1];
                    }
                    if (form.calculatortype.value == 'multipl') {
                        fieldsPatArr = qfCalculatorMultiplArr(form.elements);
                    } else if (form.calculatortype.value == 'simple') {
                        fieldsPatArr = qfCalculatorSimpleArr(form.elements);
                    }

                    priceBox.each(function() {
                        var d = $(this).data('settings');
                        var converter = function(fieldid) {
                            let str = '';
                            if (formuls[fieldid]) {
                                str = formuls[fieldid].replace(/{(.*?)}/g, function(x) {
                                    var rep = x.replace(/}|{/g, '');
                                    return fieldsPatArr[rep] ? fieldsPatArr[rep] : '(' + converter(rep) + ')';
                                });
                            }
                            return str.replace(/\(\)/g, '');
                        }

                        if (formuls[d.fieldid]) {
                            var str = converter(d.fieldid);

                            try {
                                sum = eval(chekStr(str ? str : '0'));
                                if (isNaN(sum)) {
                                    throw new Error();
                                }
                            } catch (err) {
                                return this.innerHTML = ('ERROR: ' + str);
                            }

                            sum = round(sum, d.fixed);
                            this.innerHTML = QuickForm.strPrice(sum.toFixed(d.fixed), d.format);
                            $('input[name="qfprice[]"]', $(this).parent()).val(sum);
                        }
                    });
                    $(form).trigger("qfsetprice");
                }
            }


            function chekStr(str) {
                return str.replace(/,/g, ".").replace(/[^0-9()-.+<>!=:\?\*\/|%&]/g, '');
            }

            function round(value, decimals) {
                return Number(Math.round(value + 'e' + decimals) + 'e-' + decimals);
            }

            function qfCalculator_default(fields) {
                var str = '',
                    sum, add;
                for (var n = 0; n < fields.length; n++) {
                    if (add = getAdd(fields[n])) str += add;
                }
                try {
                    sum = eval(chekStr(str ? str : '0'));
                    if (isNaN(sum)) throw new Error();
                } catch (err) {
                    $('.qfpriceinner', form).html('ERROR: ' + str);
                    return 'error';
                }
                return sum;
            }


            function qfCalculatorMultiplArr(els) {
                var arr = [];
                for (var i = 0; i < els.length; i++) {
                    var d = $(els[i]).data('settings');
                    if (d && d.fieldid) {
                        var add = getAdd(els[i]);
                        if (add !== '') arr[d.fieldid] = add;
                    }
                }
                return arr;
            }

            function qfCalculatorSimpleArr(els) {
                var arr = [];
                for (var i = 0; i < els.length; i++) {
                    if (['text', 'number', 'range', 'hidden'].indexOf(els[i].type) != -1) {
                        var d = $(els[i]).data('settings');
                        if (d && d.math) {
                            arr[d.math] = els[i].value;
                        }
                    }
                }
                return arr;
            }

            function qfCalculatorCustom(form, priceBox) {
                QuickForm.prepareFormForSend(form);
                priceBox.html(QuickForm.prelsvg());
                $.ajax({
                    type: 'POST',
                    data: $(form).serialize() + '&task=ajax.sumCustom',
                    success: function(html) {
                        var sums = html.split(';');
                        priceBox.each(function(i) {
                            var mesbox = $('.qfpricemes', $(this).parent());
                            mesbox.length || (mesbox = $('<div class="qfpricemes">').prependTo($(this).parent()));
                            mesbox.html('');
                            var d = $(this).data('settings');
                            $(sums).each(function() {
                                var pats = this.split(':');
                                if (pats.length != 2) return;
                                if (pats[0] == d.fieldid) {
                                    var sum;
                                    if (Number(pats[1]) == 1 * pats[1]) {
                                        sum = round(pats[1], d.fixed);
                                    } else {
                                        mesbox.html(pats[1]);
                                        sum = 0;
                                    }
                                    priceBox[i].innerHTML = QuickForm.strPrice(sum.toFixed(d.fixed), d.format);
                                    $('input[name="qfprice[]"]', $(priceBox[i]).parent()).val(sum);
                                }
                            });
                        });
                        $(form).trigger("qfsetprice");
                    }
                });
            }

            function getAdd(fild) {
                var add = '',
                    d;
                if (fild.type === 'select-one') {
                    d = $(fild.options[fild.selectedIndex]).data('settings');
                } else if (fild.type === 'radio' || fild.type === 'checkbox') {
                    if (fild.checked) d = $(fild).data('settings');
                } else {
                    d = $(fild).data('settings');
                }

                if (d && d.math) {
                    if (d.cond) {
                        var boxd = $(fild).parent().data('settings');
                        if (!boxd.condition || !boxd.istrue) return '';
                    }
                    add = d.math.replace(/v/g, (fild.value ? fild.value : ''));
                }
                return add;
            }

        },

        is_touch_device: function() {
            try {
                document.createEvent("TouchEvent");
                return true;
            } catch (e) {
                return false;
            }
        },

        checkMessages: function() {
            var hms = $('.qfhidemes');
            if(hms.html()) {
                var cl = hms.attr('class').replace('qfhidemes', 'qf3form');
                var box = QuickForm.qfstartoverlay(cl);
                box.append(hms.html());
                QuickForm.verticallycentr(box, true);
            }
        },

        strPrice: function(x, format) {
            var p, d;
            if (!format) {
                p = ' ';
                d = ',';
            } else if (format == 1) {
                p = ',';
                d = '.';
            } else {
                p = '';
                d = '.';
            }
            var xs = ('' + x).split('.');
            var r = xs[0].charAt(0);
            for (var n = 1; n < xs[0].length; n++) {
                if (Math.ceil((xs[0].length - n) / 3) == (xs[0].length - n) / 3) r = r + p;
                r = r + xs[0].charAt(n);
            }
            return xs[1] ? r + d + xs[1] : r;
        },

        prepareFormForSend: function(form) {
            $('input[name="qfradio[]"]', form).each(function() {
                var radios = $('input[type="radio"]', $(this).parent());
                for (var i = 0; i < radios.length; i++) {
                    if (radios[i].checked) {
                        this.value = i;
                    }
                }
            });

            $('input[name="qfcheckbox[]"]', form).each(function() {
                var chbx = $('input[type="checkbox"]', $(this).parent())[0];
                this.value = chbx.checked ? 1 : 0;
            });

            $('input[name="inpfile[][]"]', form).each(function(i) {
                this.name = 'inpfile['+i+'][]';
            });

            $('input[name="qfcloner[]"]', form).each(function() {
                var d = $(this).parent().data('settings');
                if (d.orient) {
                    this.value = $(this).parent().children('table').find("tr:gt(0)").parent().children('.qfclonerrow').length;
                } else {
                    this.value = $(this).parent().children('.qfclonerrow').length;
                }
            });

            if (!form.qftoken) {
                $(form).append('<input type="hidden" name="qftoken" value="' + form.sumbit + '">');
            }

        },

        getBodyScrollTop: function() {
            return self.pageYOffset || (document.documentElement && document.documentElement.scrollTop) || (document.body && document.body.scrollTop)
        },

        verticallycentr: function(box, flag) {
            if (!box.length) return;

            var scrll = function() {
                var bh = box.outerHeight(),
                    wh = $(window).height(),
                    gbs = QuickForm.getBodyScrollTop(),
                    bot = box.offset().top,
                    t;
                if(!bh) window.removeEventListener('scroll', scrll);
                setTimeout(function() {
                    box.stop(false, true);
                    if (bh < wh) {
                            t = (wh - bh) / 2 + gbs;
                    } else {
                        if ((bot - gbs + bh - wh) < 0)
                            t = gbs - bh + wh;
                        else if ((bot - gbs) > 0)
                            t = gbs;
                    }
                    box.animate({
                        'top': t,
                        'opacity': 1
                    }, 500, "linear");
                }, 100);
            }

            $('.qfoverlay').css('height', $(document).height());

            if (flag && !this.is_touch_device()) {
                window.addEventListener('scroll', scrll);
            }
            scrll();
        },

        keepalive: function() {
            $('.qfkeepalive').each(function() {
                if (! keepaliveflag) window.setInterval(function() {
                    $.ajax({
                        type: 'POST',
                        data: {
                            option: "com_qf3",
                            task: "ajax.related",
                            id: 0
                        }
                    });
                }, this.value);
                keepaliveflag = 1;
            });
        },

        qfstartoverlay: function(cl) {
            $('.qfoverlay').remove();
            var over = $('<div class="'+cl+' qfoverlay"></div>').appendTo(document.body);
            var qfoverop = over.css('opacity');
            var box = $('<div class="'+cl+' qfmodalform"><div class="qfclose">×</div></div>').appendTo(document.body);

            var boxclose = function() {
                var currentform = $('form', box);
                if(currentform.length) {
                    qfrecords[currentform[0].id.value] = currentform;
                }
                over.add(box).stop(true).animate({
                    'opacity': 0
                }, 600, function() {
                    $(this).remove();
                });
            }

            $('.qfclose').click(function() {
                boxclose();
            })

            over.css({
                'opacity': 0,
                'height': $(document).height()
            }).animate({
                'opacity': qfoverop
            }, 600).click(function() {
                boxclose();
            });

            box.css({
                'opacity': 0,
                'top' : QuickForm.getBodyScrollTop()
            });

            return box;
        },

        qfstartModalform: function(el) {
            var id =$(el).data('project');
            var cl = $(el).attr('class').replace('qf3modal', 'qf3form');
            var box = QuickForm.qfstartoverlay(cl);

            if (qfrecords[id]) {
                box.append(qfrecords[id]);
                QuickForm.verticallycentr(box, true);
                var form = $('form', box)[0];
                QuickForm.initiate(form);
                return;
            }

            $.ajax({
                type: 'POST',
                data: {
                    option: "com_qf3",
                    task: "ajax.qfmodal",
                    id: id
                },
                success: function(html) {
                    box.append(html);
                    QuickForm.verticallycentr(box, true);
                    var form = $('form', box)[0];
                    QuickForm.initiate(form);
                }
            });

            return;
        },
        
        prelsvg: function() {
          return '<svg width="80px" height="10px" viewBox="0 0 128 16" xml:space="preserve"><path fill="#949494" d="M6.4,4.8A3.2,3.2,0,1,1,3.2,8,3.2,3.2,0,0,1,6.4,4.8Zm12.8,0A3.2,3.2,0,1,1,16,8,3.2,3.2,0,0,1,19.2,4.8ZM32,4.8A3.2,3.2,0,1,1,28.8,8,3.2,3.2,0,0,1,32,4.8Zm12.8,0A3.2,3.2,0,1,1,41.6,8,3.2,3.2,0,0,1,44.8,4.8Zm12.8,0A3.2,3.2,0,1,1,54.4,8,3.2,3.2,0,0,1,57.6,4.8Zm12.8,0A3.2,3.2,0,1,1,67.2,8,3.2,3.2,0,0,1,70.4,4.8Zm12.8,0A3.2,3.2,0,1,1,80,8,3.2,3.2,0,0,1,83.2,4.8ZM96,4.8A3.2,3.2,0,1,1,92.8,8,3.2,3.2,0,0,1,96,4.8Zm12.8,0A3.2,3.2,0,1,1,105.6,8,3.2,3.2,0,0,1,108.8,4.8Zm12.8,0A3.2,3.2,0,1,1,118.4,8,3.2,3.2,0,0,1,121.6,4.8Z"/><g><path fill="#000000" d="M-42.7,3.84A4.16,4.16,0,0,1-38.54,8a4.16,4.16,0,0,1-4.16,4.16A4.16,4.16,0,0,1-46.86,8,4.16,4.16,0,0,1-42.7,3.84Zm12.8-.64A4.8,4.8,0,0,1-25.1,8a4.8,4.8,0,0,1-4.8,4.8A4.8,4.8,0,0,1-34.7,8,4.8,4.8,0,0,1-29.9,3.2Zm12.8-.64A5.44,5.44,0,0,1-11.66,8a5.44,5.44,0,0,1-5.44,5.44A5.44,5.44,0,0,1-22.54,8,5.44,5.44,0,0,1-17.1,2.56Z"/><animateTransform attributeName="transform" type="translate" values="23 0;36 0;49 0;62 0;74.5 0;87.5 0;100 0;113 0;125.5 0;138.5 0;151.5 0;164.5 0;178 0" calcMode="discrete" dur="1170ms" repeatCount="indefinite"/></g></svg>';
        },
        
        preloader: function() {
          var el = $('<div class="preloaderoverlay">'+this.prelsvg()+'</div>').css('display','none');
          $('svg', el).css({'position':'absolute','top':'50%','left':'50%','margin-left':'-40px','margin-top':'-5px'});
          setTimeout(() => {
            el.show(1000);
          }, 1000);
          return el;
        }

    }
})(jQuery);

