(function($) {
    $(document).ready(function() {
        $(document).on('click', '.qf_cart_sum', function() {
            QFcart.getCartBox();
        });
        QFcart.updateMiniCart();
    });

    var actions = {
        start: function() {
            var $preloader = $('<div id="jpreloader" class="preloader-overlay"><div class="loader" style="position:absolute;left:50%;top:50%;margin-left:-32px;margin-top:-32px;"><svg xmlns:svg="http://www.w3.org/2000/svg" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.0" width="64px" height="64px" viewBox="0 0 128 128" xml:space="preserve"><rect x="0" y="0" width="100%" height="100%" fill="#f3ffff" /><path fill="#000000" fill-opacity="1" d="M64.4 16a49 49 0 0 0-50 48 51 51 0 0 0 50 52.2 53 53 0 0 0 54-52c-.7-48-45-55.7-45-55.7s45.3 3.8 49 55.6c.8 32-24.8 59.5-58 60.2-33 .8-61.4-25.7-62-60C1.3 29.8 28.8.6 64.3 0c0 0 8.5 0 8.7 8.4 0 8-8.6 7.6-8.6 7.6z"><animateTransform attributeName="transform" type="rotate" from="0 64 64" to="360 64 64" dur="1800ms" repeatCount="indefinite"></animateTransform></path></svg></div></div>');
            $preloader.css({
                'width': '100%',
                'height': $(document).height(),
                'left': '0',
                'top': '0',
                'z-index': '99999',
                'position': 'absolute'
            });
            this.append($preloader);
            QuickForm.verticallycentr(this.find('.loader'), true);
        },

        stop: function() {
            this.find('.preloader-overlay').remove();
        }
    };

    $.fn.preloader = function(action) {
        actions[action].apply(this);
        return this;
    };

    return QFcart = {
        getCartBox: function() {
            if ($('.qfcartoverlay').length) {
                $('.qfcartoverlay').remove();
            }
            if ($('.qfcartform').length) {
                $('.qfcartform').remove();
            }

            var over = $('<div class="qfcartoverlay"></div>').appendTo(document.body);
            var qfoverop = over.css('opacity');
            var box = $('<div class="qfcartform"><div class="qfcartclose">✕</div></div>').appendTo(document.body);
            var box2 = $('<div class="qfcartforminner"></div>').appendTo(box);

            $.ajax({
                type: 'POST',
                data: {
                    option: "com_qf3",
                    task: "ajax.qfcart"
                },
                success: function(res) {
                    box2.append(res);
                    boxActivate(box);
                    QuickForm.verticallycentr(box, true);
                },
            });

            over.css({
                'display': 'block',
                'opacity': 0,
                'height': $(document).height()
            }).animate({
                'opacity': qfoverop
            }, 600).click(function() {
                boxclose();
            });

            box.css({
                'display': 'block',
                'opacity': 0
            });

            var boxclose = function() {
                if ($('#qf_contacts').length) {
                    $('#qf_contacts').animate({
                        'opacity': 0
                    }, 600, function() {
                        $(this).remove();
                    });
                    $('.qfcartform').show().animate({
                        'opacity': 1
                    }, 800);
                    QuickForm.verticallycentr(box, false);
                } else if ($('.atch_box').length) {
                    $('.atch_box').animate({
                        'opacity': 0
                    }, 600, function() {
                        $(this).remove();
                    });
                    $('.qfcartform').show().animate({
                        'opacity': 1
                    }, 800);
                    QuickForm.verticallycentr(box, false);
                } else {
                    over.add(box).stop().animate({
                        'opacity': 0
                    }, 300, function() {
                        $(this).remove();
                    });
                }
            }

            $(document).on('click', '.qfcartclose', function() {
                boxclose();
            });

            function boxActivate(box) {
                $('.qf_td_1 span', box).each(function(i, v) {
                    this.onclick = function() {
                        removeRow(i, this);
                    }
                });

                $('.qf_td_5 input', box).each(function(i, v) {
                    this.onchange = function() {
                        changeRow(i, this);
                    }
                })

                $('.atch', box).each(function(i, v) {
                    this.onclick = function() {
                        upload_layouts(i, this);
                    }
                });

                var qfforms = $('.qf3form form', box);

                qfforms.each(function() {
                    QuickForm.initiate(this);
                    checkforfinalprice(this);
                });
                sum();

                var discount_box = $('.qf_cart_discount');

                qfforms.on('qfsetprice', function() {
                    $('.finalpricerow').remove();
                    qfforms.each(function() {
                        checkforfinalprice(this);
                    });
                    sum();
                    if (discount_box.length) {
                        activateDiscaunt(discount_box);
                    }
                });

                if (discount_box.length) {
                    activateDiscaunt(discount_box);
                }
            }

            function activateDiscaunt(box) {
                doDiscounts();
                var btn = $('input[name=disbut]', box);
                btn.on('click', function() {
                    if (this.className != 'enabled' && !this.form.checkValidity()) {
                        return $('<input type="submit">').hide().appendTo(this.form).click().remove();
                    } else if (this.className == 'enabled') {
                        $('input[name=disinp]', box).val('');
                    }
                    getPromocod(this);
                });
                if ($('input[name=disinp]', box).val()) {
                    getPromocod(btn[0]);
                }
            }

            function getPromocod(btn) {
                $.ajax({
                    type: 'POST',
                    data: {
                        option: "com_qf3",
                        task: "ajax.qfcartpromocod",
                        cod: $('input[name=disinp]', box).val()
                    },
                    success: function(res) {
                        if (res) {
                            var el = $('input[name="qfprice[]"]', $('#qf_resultprice'))[0];
                            var price = el.value;
                            var unit = $(el).data('unit');
                            var discount = price * res / 100;

                            $('.finalpricerow').remove();

                            var html = '<label>'+ qf_txt_discount + ' '+ res + '%</label><span class="qfpriceinner">-' + round(discount) + '</span><span class="qfunitinner">' + unit + '</span><input name="qfprice[]" type="hidden" value="-' + discount + '" data-unit="' + unit + '">';
                            var div = document.createElement('div');
                            div.className = "finalpricerow";
                            div.innerHTML = html;
                            div = $(div).appendTo('#qf_resultprice');
                            $('.qf_cart_foot_l .qf3form form').each(function() {
                                checkforfinalprice(this);
                            });
                            sum();
                            btn.className = 'enabled';
                            btn.value = qf_txt_dis;
                        } else {
                            $('.finalpricerow').remove();
                            $('.qf_cart_foot_l .qf3form form').each(function() {
                                checkforfinalprice(this);
                            });
                            sum();
                            btn.className = '';
                            btn.value = qf_txt_act;
                            doDiscounts();
                        }
                    }
                });

            }

            function doDiscounts() {
                if (!qf_cart_discount) return;
                var el = $('input[name="qfprice[]"]', $('#qf_resultprice'))[0];
                var price = el.value;
                var unit = $(el).data('unit');
                var ar, disc, arr = qf_cart_discount.split('%');
                for (var i = 0; i < arr.length; i++) {
                    ar = arr[i].split('-');
                    if (+ar[0] < +price && +price <= +ar[1]) {
                        disc = ar[2];
                        break;
                    }
                }
                if (disc) {
                    var discount = price * disc / 100;

                    $('.finalpricerow').remove();

                    var html = '<label>'+ qf_txt_discount + ' '+ disc + '%</label><span class="qfpriceinner">-' + round(discount) + '</span><span class="qfunitinner">' + unit + '</span><input name="qfprice[]" type="hidden" value="-' + discount + '" data-unit="' + unit + '">';
                    var div = document.createElement('div');
                    div.className = "finalpricerow";
                    div.innerHTML = html;
                    div = $(div).appendTo('#qf_resultprice');
                    $('.qf_cart_foot_l .qf3form form').each(function() {
                        checkforfinalprice(this);
                    });
                    sum();
                }
            }

            function round(value) {
                return QuickForm.strPrice(Number(Math.round(value + 'e' + qf_cart_fixed) + 'e-' + qf_cart_fixed).toFixed(qf_cart_fixed),qf_cart_format);
            }

            function sum() {
                var arr = [],
                    html = '';
                var pricebox = $('#qf_resultprice');
                var els = $('input[name="qfprice[]"]', pricebox);

                els.each(function() {
                    var u = $(this).data('unit');
                    if (!arr[u]) arr[u] = 1 * this.value;
                    else arr[u] += 1 * this.value;
                });

                for (var u in arr) {
                    if (!arr.hasOwnProperty(u)) continue;
                    html += '<div><label class="qf3label">' + pricebox.data('text_price_total') + '</label><span class="qfpriceinner">' + round(arr[u]) + '</span><span class="qfunitinner">' + u + '</span></div>';
                }

                var div = document.createElement('div');
                div.className = "finalpricerow total";
                div.innerHTML = html;
                div = $(div).appendTo('#qf_resultprice');
            }

            function checkforfinalprice(form) {

                $('.qfcalculatorsum', form).each(function() {
                    var div = document.createElement('div');
                    div.className = "finalpricerow";
                    div.innerHTML = this.innerHTML;
                    div = $(div).appendTo('#qf_resultprice');
                })
            }


            function changeRow(i, el) {
                box2.animate({
                    'opacity': 0
                }, 300);
                $.ajax({
                    type: 'POST',
                    data: {
                        option: "com_qf3",
                        task: "ajax.qfcartchangerow",
                        num: i,
                        val: el.value
                    },
                    success: function(res) {
                        box2.html(res).css('opacity', 0).animate({
                            'opacity': 1
                        }, 300);
                        QuickForm.verticallycentr(box, false);
                        boxActivate(box);
                        QFcart.updateMiniCart();
                    }
                });
            }


            function removeRow(i, el) {
                $(el).closest('tr').animate({
                    'opacity': 0
                }, 900);

                $.ajax({
                    type: 'POST',
                    data: {
                        option: "com_qf3",
                        task: "ajax.qfcartremrow",
                        num: i
                    },
                    success: function(res) {
                        $(el).closest('tr').stop().animate({
                            'opacity': 0
                        }, 300, function() {
                            box2.html(res).css('opacity', 0).animate({
                                'opacity': 1
                            }, 600);
                            QuickForm.verticallycentr(box, false);
                            boxActivate(box);
                            QFcart.updateMiniCart();
                        });
                    }
                });
            }


            function upload_layouts(i, el) {
                var box = $('<div class="atch_box"><div class="qfcartclose">✕</div><div>').appendTo(document.body);
                box.css({
                    'display': 'block',
                    'opacity': 0
                });
                $('.qfcartform').animate({
                    'opacity': 0
                }, 800, function() {
                    $(this).hide();
                    QuickForm.verticallycentr($('.qfcartform'), false);
                });
                $.ajax({
                    type: 'POST',
                    data: {
                        option: "com_qf3",
                        task: "ajax.showAttachmentBox",
                        num: i
                    },
                    success: function(res) {
                        box.append(res);
                        QuickForm.verticallycentr(box, true);
                        $('.qfcartclose', box).click(function() {
                            boxclose();
                        });
                        activateUploadBox(box, i);
                    }
                });
            }

            function activateUploadBox(box, iii) {
                var PR_formData = [],
                    iimg = 0;
                $(".atch_area").click(function() {
                    $("#file_field").click();
                });
                $("#file_field").bind({
                    change: function() {
                        displayFiles(this.files);
                    }
                });

                box.bind({
                    dragover: function() {
                        return false;
                    },
                    drop: function(e) {
                        var files = e.originalEvent.dataTransfer.files;
                        if (files.length) {
                            event.preventDefault();
                            event.stopPropagation();
                            return displayFiles(files);
                        }
                    },
                    dragenter: function(e) {
                        $(this).css('border-color', 'green');
                    },
                    dragleave: function(e) {
                        $(this).css('border-color', '#ccc');
                    }
                });

                $('.atch_link_more a').on('click', function() {
                    $('.atch_link:last').after('<div class="atch_link"><input type="text" placeholder="'+ $('.atch_link input').attr('placeholder') +'"></div>');
                    checkLinks();
                    QuickForm.verticallycentr(box, false);
                    return false;
                });
                checkLinks();

                $('.atch_reset').click(function() {
                    boxclose();
                });

                $('.atch_send', box).click(function() {
                    box_layouts_send();
                });

                $('.del_old_img', box).click(function() {
                    del_old_img(this);
                });

                function del_old_img(el) {
                    var imgbox = $(el).parent('.imgtbox_old');
                    var spl = imgbox.find('.del_old').data('href');
                    if (spl) {
                        box.preloader('start');
                        $.ajax({
                            type: 'POST',
                            data: {
                                option: "com_qf3",
                                task: "ajax.attachment_del_img",
                                name: spl,
                                num: iii
                            },
                            success: function(res) {
                                box.preloader('stop');
                                if (res == 'yes') {
                                    imgbox.remove();
                                    QuickForm.verticallycentr(box, false);
                                } else {
                                    $('.atch_message').fadeIn().html(res).delay(2500).fadeOut(1500);
                                }
                            }
                        });
                    }
                }

                function box_layouts_send() {
                    var links = [],
                        files = [];
                    $('.atch_link input', box).each(function() {
                        if (this.value) links.push(this.value);
                    });
                    for (var i = 0; i < PR_formData.length; i++) {
                        if (PR_formData[i]) files.push(PR_formData[i]);
                    }
                    var txtarea = $('.atch_coment textarea', box).val();

                    box.preloader('start');

                    var fD = new FormData();
                    for (var i = 0; i < files.length; i++) {
                        fD.append('imagefile[' + i + ']', files[i]);
                    }
                    for (var i = 0; i < links.length; i++) {
                        fD.append('imagelinks[' + i + ']', links[i]);
                    }
                    fD.append('imagecoment', txtarea);
                    fD.append('option', 'com_qf3');
                    fD.append('task', 'ajax.sessionLoading');
                    fD.append('num', iii);

                    $.ajax({
                        data: fD,
                        processData: false,
                        contentType: false,
                        type: 'POST',
                        success: function(data) {
                            box.preloader('stop');
                            if (data) {
                                if (data.indexOf("label:") == 0) {
                                    $('.atch')[iii].innerHTML = data.slice(7);
                                    boxclose();
                                } else {
                                    $('.atch_message').fadeIn().html(data).delay(3500).fadeOut(1500);
                                }
                            }
                        }
                    });
                }

                function checkLinks() {
                    var links = $('.atch_link');
                    $('a', links).remove();
                    if (links.length > 1) {
                        $('✕'.link('#')).appendTo(links).click(function() {
                            $(this).parent().remove();
                            checkLinks();
                            QuickForm.verticallycentr(box, false);
                            return false;
                        });
                    }
                }

                function displayFiles(files) {
                    var err = '',
                        accept = $('#file_field').data('accept');
                    if (accept) accept = accept.split(",");
                    $.each(files, function(i, file) {
                        var k = iimg;
                        var ext = file.name.split(".").pop().toLowerCase();
                        if (!accept || $.inArray(ext, accept) != -1) {
                            var ibox = $('<div class="imgtbox_new"></div>').appendTo('.filelisting');
                            var ateg = $('<div class="file_name">' + file.name + ' (' + (file.size / 1024 / 1024).toFixed(2) + 'M)</div>').appendTo(ibox);
                            var del = $('<span class="imgtdel">✕</span>').appendTo(ibox).on('click', function() {
                                ibox.remove();
                                delete PR_formData[k];
                            });
                            PR_formData[iimg] = file;
                            iimg++;
                            QuickForm.verticallycentr(box, false);
                        } else {
                            err += '<br>error: File type not supported: ' + file.name;
                        }
                    });
                    err ? $('.atch_message').fadeIn().html(err).delay(5000).fadeOut(1500) : 0;
                }
            }
        },

        updateMiniCart: function() {
            $.ajax({
                type: 'POST',
                data: {
                    option: "com_qf3",
                    task: "ajax.updateminicart"
                },
                success: function(res) {
                    $('.qf_cart_box').html(res);
                    $('#qfshuttle').html(res);
                }
            });
        },

        checkreqfiles: function() {
            var fl;
            $('.atch a').each(function() {
                var el = $(this);
                if (el.data('req')) {
                    var col = el.css('color');
                    el.animate({
                        'opacity': 0
                    }, 300, function() {
                        el.css('color', '#ff0000').animate({
                            'opacity': 1
                        }, 600, function() {
                            el.animate({
                                'opacity': 0
                            }, 600, function() {
                                el.css('color', col).animate({
                                    'opacity': 1
                                }, 600);
                            });
                        });
                    });
                    fl = true;
                }
            });
            if (!fl) return true;
        },

        cartnext: function() {
            var fl, fs = $('#qf_delivery .qf3form form').add($('#qf_payment .qf3form form'));
            fs.each(function() {
                if (!this.checkValidity()) {
                    fl=1;
                    return this.submit();
                }
            });

            if (fl || !QFcart.checkreqfiles()) return false;

            var box = $('.qfcartform').hide();
            $.ajax({
                type: 'POST',
                data: {
                    option: "com_qf3",
                    task: "ajax.cartcontacts"
                },
                success: function(res) {
                    var box2 = $(res).appendTo(box.parent());
                    QuickForm.verticallycentr(box2, true);
                    var form = $('#qf_contacts .qf3form form', box.parent())[0];
                    QuickForm.initiate(form);
                }
            });
        },

        cartsubmit: function (form) {
            var fl, dat, n = 0;
            var forms = $('.qf_cart_foot_l .qf3form form, #qf_contacts .qf3form form');
            form.sumbit = form.root.value.replace(/[w.|-]/g, '').split(/\/+/)[1];
            QuickForm.prepareFormForSend(form);

            forms.each(function() {
                if (!this.checkValidity()) {
                    fl = 1;
                    return this.submit();
                }
            });

            if (fl || !QFcart.checkreqfiles()) return false;

            $('.qfcartform').animate({
                'opacity': 0
            }, 900);

            $('.qfcartform').parent().preloader('start');

            var send = function(f) {
                QuickForm.prepareFormForSend(f);
                var pr = true;
                if (!window.FormData)
                    dat = $(f).serialize() + '&task=ajax.confirmCart';
                else {
                    dat = new FormData(f);
                    dat.set('task', 'ajax.confirmCart');
                    pr = false;
                }

                $.ajax({
                    type: 'POST',
                    url: form.root.value,
                    data: dat,
                    processData: pr,
                    contentType: pr,
                    success: function(res) {
                        if (res == 'yes') {
                            n++;
                            if (n < forms.length) {
                                send(forms[n]);
                            } else {
                                form.submit();
                            }
                        }
                    }
                });
            }

            if (forms.length) {
                send(forms[0]);
            } else {
                form.submit();
            }
        },

        addFormInCart: function(form) {
            QuickForm.prepareFormForSend(form);
            if (!form.checkValidity()) {
                return form.submit();
            }
            $.ajax({
                type: 'POST',
                url: form.root.value,
                data: $(form).serialize() + '&task=ajax.ajaxminicart',
                success: function(res) {
                    QFcart.animateMiniCart(res);
                }
            });
            return false;
        },

        animateMiniCart: function(res) {
            var over = $('<div class="qfcartoverlay"></div>').appendTo(document.body);
            over.css({
                'display': 'block',
                'height': $(document).height()
            }).animate({
                'opacity': 0
            }, 400, function() {
                $(this).remove();
            });
            updateShuttle();

            $('.qf_cart_box').animate({
                'opacity': 0
            }, 300, function() {
                $(this).html(res);
                $(this).animate({
                    'opacity': 1
                }, 600);
            });

            function updateShuttle() {
                var shuttleAnimate = function(shut) {
                    shut.animate({
                        'opacity': 1
                    }, 2000, function() {
                        shut.animate({
                            'opacity': 0.2
                        }, 2000);
                        $('.qf_h ', shut).hide(600);
                    })
                }
                var shut = $('#qfshuttle');
                if (!shut.length) {
                    shut = $('<div id="qfshuttle">' + res + '</div>');
                    shuttleAnimate(shut.appendTo('body'));
                    shut.on('mouseover', function() {
                        $(this).stop().animate({
                            'opacity': 1
                        }, 600);
                        $('.qf_h ', shut).show(300);
                    }).on('mouseleave', function() {
                        $(this).stop().animate({
                            'opacity': 0.2
                        }, 600);
                        $('.qf_h ', shut).hide(300);
                    }).on('click', function() {
                        QFcart.getCartBox();
                    });
                } else {
                    shut.html(res);
                    shuttleAnimate(shut);
                }

                var mes = $('#qfshuttle .qfhidemescart').html();
                if(mes) {
                    var box = QuickForm.qfstartoverlay('qf3form mess');
                    box.append(mes);
                    QuickForm.verticallycentr(box, true);
                    $('.qfhidemescart').remove();
                }

            }
        },

    };

})(jQuery);
